/**
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 */
package nl.cloudfarming.client.isobus.type;

import nl.cloudfarming.client.isobus.model.BinaryDataType;
import nl.cloudfarming.client.isobus.model.XmlField;

/**
 * enum which describes the datatypes of the Grid object
 *
 * @author Merijn Zengers
 */
public enum GridFieldEnum implements XmlField {
    //GRD : J TreatmentZoneCode

    TREATMENT_ZONE_CODE_TYPE("J", BinaryDataType.BIT8_UNSIGNED),
    TREATMENT_ZONE_VALUE_TYPE("J", BinaryDataType.BIT32_SIGNED);
    String xmlField = "";
    BinaryDataType dataType = null;

    GridFieldEnum(String xmlField, BinaryDataType dataType) {
        this.xmlField = xmlField;
        this.dataType = dataType;
    }

    @Override
    public String getAttributeName() {
        return xmlField;
    }

    @Override
    public BinaryDataType getDataType() {
        return dataType;
    }
}
