/**
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 */
package nl.cloudfarming.client.isobus.type;

import nl.cloudfarming.client.isobus.model.IsobusTreatmentZone;


/**
 * Class which can be used to store a grid in
 * This grid contains IsobusTreatmentZones
 * 
 * @author Merijn Zengers
 * @deprecated use IsobusValueGrid
 */
@Deprecated
public class IsobusTreatmentZoneGrid {
    private IsobusTreatmentZone[][] grid;
    private int numberOfColumn;
    private int numberOfRows;
    
    public IsobusTreatmentZoneGrid(int numberOfRows, int numberOfColumn){
        grid = new IsobusTreatmentZone[numberOfRows][numberOfColumn];
        this.numberOfRows = numberOfRows;
        this.numberOfColumn = numberOfColumn;
    }
    
    /**
     * Inserts a IsobusTreatmentZone at the specified row and column
     * Take notice!! this will replace the value current on this row column if there is any 
     * @param column
     * @param row
     * @param treatmentZone 
     */
    public void insert(int row, int column, IsobusTreatmentZone treatmentZone){
        grid[row][column] = treatmentZone;
    }
    
    /**
     * Get the IsobusTreatmentZone 
     * @param column
     * @param row
     * @return 
     */
    public IsobusTreatmentZone getTreatmentZone(int row, int column){
        return grid[row][column];
    }
    
    /**
     * Gets a row from the grid
     * @param rowNum
     * @return 
     */
    public IsobusTreatmentZone[] getRow(int rowNum){
        return grid[rowNum];
    }
        
    
    /**
     * Get the number of columns in this grid
     * @return 
     */
    public int getNumberOfColumn() {
        return numberOfColumn;
    }

    /**
     * Get the number of rows for this grid 
     * @return 
     */
    public int getNumberOfRows() {
        return numberOfRows;
    }
    
    public int getSize(){
        return numberOfColumn * numberOfRows;
    }
    
    
    
    
}
